/*
 * Andrea Di Biagio
 * Politecnico di Milano, 2007
 * 
 * axe_array.c
 * Formal Languages & Compilers Machine, 2007/2008
 * The ACSE software is distributed under the terms of the General Public License, version 2; use it at your own risk.
 * 
 */

#include "axe_array.h"
#include "axe_gencode.h"
#include "symbol_table.h"
#include "axe_utils.h"
#include "axe_errors.h"
#include <stdio.h>

void storeArrayElement(t_program_infos *program, char *ID
            , t_axe_expression index, t_axe_expression data)
{
   //int address;
   
   //address =  loadArrayAddress(program, ID, index);

	t_axe_label* label;
	label = getLabelFromVariableID(program, ID);

if (data.expression_type == REGISTER)
   {
      /* load the value indirectly into `mova_register' */
      //gen_add_instruction(program, address, REG_0
      //         , data.value, CG_INDIRECT_DEST);
      //if(index.expression_type == REGISTER){
        //   gen_store_instruction(program, data.value, index.value, 0, label, 0);
      //}
      //else{
           gen_store_array_instruction(program, data.value, index.value, label, 0);
      //}
   }
   else
   {
      int imm_register;

      //imm_register = load_immediate(program, data.value);
      imm_register = get_symbol_location(program, ID, 0);
	//Move the immediate value to a register
	gen_jit_movi_i_instruction(program, imm_register, data.value);

        gen_store_array_instruction(program, imm_register, index.value, label, 0);

   }



}


int loadArrayElement(t_program_infos *program
               , char *ID, t_axe_expression index)
{
   int load_register;
   //int address;
   
	t_axe_label* label;
	label = getLabelFromVariableID(program, ID);

   // retrieve the address of the array slot 
   //address = loadArrayAddress(program, ID, index);
   // get a new register 
   load_register = get_symbol_location(program, ID, 0);

   // load the value into `load_register'
   gen_load_array_instruction(program, load_register, index.value, label, CG_INDIRECT_SOURCE);

    //return the register ID that holds the required data
   return load_register;
}



