/*
 * Andrea Di Biagio
 * Politecnico di Milano, 2007
 * 
 * axe_constants.h
 * Formal Languages & Compilers Machine, 2007/2008
 * The ACSE software is distributed under the terms of the General Public License, version 2; use it at your own risk.
 * 
 */

#ifndef _AXE_CONSTANTS_H
#define _AXE_CONSTANTS_H

/* registers */

#define REG_INVALID -1
#define REG_0 0
#define NUM_REGISTERS 9

/* opcodes pseudo-M68000 */
#define ADD 0
#define SUB 1
#define ANDL 2
#define ORL 3
#define EORL 4
#define JIT_ADDXR_I 5
#define JIT_ADDCR_I 6
#define JIT_SUBXR_I 7
#define MUL 8
#define DIV 9
#define SHL 10
#define SHR 11
#define JIT_SUBCR_I 12
#define JIT_RSBR_I 13
#define JIT_HMULR_I 14
#define JIT_MODR_I 15
#define ADDI 16
#define SUBI 17
#define ANDLI 18
#define ORLI 19
#define EORLI 20
#define JIT_ADDXI_I 21
#define JIT_ADDCI_I 22
#define JIT_SUBXI_I 23
#define MULI 24
#define DIVI 25
#define SHLI 26
#define SHRI 27
#define JIT_SUBCI_I 28
#define JIT_RSBI_I 29
#define JIT_HMULI_I 30
#define JIT_MODI_I 31
#define NOP 32
#define MOVA 33
#define JSR 34
#define RET 35
#define HALT 36
#define JIT_EQI_I 37
#define JIT_GEI_I 38
#define JIT_GTI_I 39
#define JIT_LEI_I 40
#define JIT_LTI_I 41
#define JIT_NEI_I 42
#define BT 43
#define BF 44
#define JIT_BLTI_I 45
#define JIT_BLTR_I 46
#define JIT_BGTI_I 47
#define JIT_BGTR_I 48
#define JIT_BLEI_I 49
#define JIT_BLER_I 50
#define JIT_BGEI_I 51
#define JIT_BGER_I 52
#define JIT_BEQI_I 53
#define JIT_BEQR_I 54
#define JIT_BNEI_I 55
#define JIT_BNER_I 56
#define JIT_BMSI_I 57
#define JIT_BMCI_I 58
#define LOAD 59
#define STORE 60
#define AXE_READ 61
#define AXE_WRITE 62
#define JIT_EQR_I 63
#define JIT_GER_I 64
#define JIT_GTR_I 65
#define JIT_LER_I 66
#define JIT_LTR_I 67
#define JIT_NER_I 68
#define JIT_BOADDI_I 69
#define JIT_BOSUBI_I 75
#define JIT_BMSR_I 70
#define JIT_BMCR_I 71
#define JIT_BOADDR_I 72
#define JIT_BOSUBR_I 73
#define JIT_MOVI_I 74
#define JIT_LOAD_I 76
#define JIT_STORE_I 77
#define NOTL 78
#define JIT_STI_I 79
#define JIT_LDR_I 80
#define INVALID_OPCODE -1

/* data types */
#define INTEGER_TYPE 0
#define UNKNOWN_TYPE -1

/* label special values */
#define LABEL_UNSPECIFIED -1

/* WARNINGS */
#define WARN_DIVISION_BY_ZERO 1

/* SIM errorcodes */
#define AXE_OK 0
#define AXE_OUT_OF_MEMORY 1
#define AXE_PROGRAM_NOT_INITIALIZED 2
#define AXE_INVALID_INSTRUCTION 3
#define AXE_VARIABLE_ID_UNSPECIFIED 4
#define AXE_VARIABLE_ALREADY_DECLARED 5
#define AXE_INVALID_TYPE 6
#define AXE_FOPEN_ERROR 7
#define AXE_FCLOSE_ERROR 8
#define AXE_INVALID_INPUT_FILE 9
#define AXE_FWRITE_ERROR 10
#define AXE_INVALID_DATA_FORMAT 11
#define AXE_INVALID_OPCODE 12
#define AXE_INVALID_REGISTER_INFO 13
#define AXE_INVALID_LABEL 14
#define AXE_INVALID_ARRAY_SIZE 15
#define AXE_INVALID_VARIABLE 16
#define AXE_INVALID_ADDRESS 17
#define AXE_INVALID_EXPRESSION 18
#define AXE_UNKNOWN_VARIABLE 19
#define AXE_LABEL_ALREADY_ASSIGNED 20
#define AXE_INVALID_LABEL_MANAGER 21
#define AXE_SY_TABLE_ERROR 22
#define AXE_NULL_DECLARATION 23
#define AXE_INVALID_CFLOW_GRAPH 24
#define AXE_INVALID_REG_ALLOC 25
#define AXE_REG_ALLOC_ERROR 26
#define AXE_TRANSFORM_ERROR 27
#define AXE_SYNTAX_ERROR 28
#define AXE_UNKNOWN_ERROR 29

/* DIRECTIVE TYPES */
#define DIR_WORD 0
#define DIR_SPACE 1
#define DIR_INVALID -1

/* ADDRESS TYPES */
#define ADDRESS_TYPE 0
#define LABEL_TYPE 1

/* CODEGEN FLAGS */
#define CG_DIRECT_ALL 0
#define CG_INDIRECT_ALL 3
#define CG_INDIRECT_DEST 1
#define CG_INDIRECT_SOURCE 2

/* EXPRESSION TYPES */
#define IMMEDIATE 0
#define REGISTER 1
#define INVALID_EXPRESSION -1

/* binary comparison constants */
#define _LT_ 0
#define _GT_ 1
#define _EQ_ 2
#define _NOTEQ_ 3
#define _LTEQ_ 4
#define _GTEQ_ 5

#endif
